

import org.omg.CORBA.ORB;

import java.util.Enumeration;
import java.util.Hashtable;


class c
{

    public static void main (String argv[])
    {
	Hashtable unitNames = new Hashtable();

	unitNames.put(ExampleB.TempUnit.CELSIUS,    "Grad Celsius");
	unitNames.put(ExampleB.TempUnit.KELVIN,     "Kelvin");
	unitNames.put(ExampleB.TempUnit.FAHRENHEIT, "Grad Fahrenheit");


	try
	{

	    ORB orb = ORB.init(argv, null);

	    String objName = "corbaname::localhost:2809#" + argv[0];

	    ExampleC.Thermometer therm = ExampleC.ThermometerHelper.narrow(
		orb.string_to_object( objName ));

	    if (therm == null)
	    {
	    	System.err.println("Objekt '" + objName + "' nicht gefunden!");
		System.exit(1);
	    }

	    System.out.println("Verbindung mit Objekt '" + objName + "':");

	    for (Enumeration e = unitNames.keys(); e.hasMoreElements(); )
	    {
		try
		{
		    ExampleB.TempUnit tUnit = (ExampleB.TempUnit) e.nextElement();

		    double t = therm.getTemperatureInUnit(tUnit);

		    System.out.println ("Die Temperatur in " +
			therm.location() + " betraegt: " +
			t + " " + (String) unitNames.get(tUnit));
		}
		catch (ExampleC.CannotConvertUnit ex)
		{
		    System.err.println("Fehler: Das Thermometer kann die "
		     + "intern benutzte Einheit '" 
		     + (String) unitNames.get(ex.fromUnit)
		     + "' nicht in die gewuenschte Einheit '"
		     + (String) unitNames.get(ex.toUnit) + "' umwandeln.");
		}
	    }
	}
	catch (Exception ex)
	{
	    System.err.println("Exception: " + ex);
	}
    }
}

